"use strict";
/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.dev/license
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCompilerPlugin = void 0;
const tslib_1 = require("tslib");
const devkit_1 = require("./utils/devkit");
function createCompilerPlugin(pluginOptions, isTest) {
    const javascriptTransformer = new devkit_1.JavaScriptTransformer(pluginOptions, 1);
    return {
        name: 'analogjs-angular-esbuild-deps-optimizer-plugin',
        setup(build) {
            return tslib_1.__awaiter(this, void 0, void 0, function* () {
                if (!isTest) {
                    build.onLoad({ filter: /\.[cm]?js$/ }, (args) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                        const contents = yield javascriptTransformer.transformFile(args.path);
                        return {
                            contents,
                            loader: 'js',
                        };
                    }));
                }
                build.onEnd(() => javascriptTransformer.close());
            });
        },
    };
}
exports.createCompilerPlugin = createCompilerPlugin;
//# sourceMappingURL=compiler-plugin.js.map