"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.augmentHostWithResources = void 0;
const tslib_1 = require("tslib");
const paths_1 = require("@ngtools/webpack/src/ivy/paths");
function augmentHostWithResources(host, transform, options = {}) {
    const resourceHost = host;
    resourceHost.readResource = function (fileName) {
        const filePath = (0, paths_1.normalizePath)(fileName);
        const content = this.readFile(filePath);
        if (content === undefined) {
            throw new Error('Unable to locate component resource: ' + fileName);
        }
        return content;
    };
    resourceHost.transformResource = function (data, context) {
        var _a;
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            // Only style resources are supported currently
            if (context.type !== 'style') {
                return null;
            }
            if (options.inlineStylesExtension) {
                // Resource file only exists for external stylesheets
                const filename = (_a = context.resourceFile) !== null && _a !== void 0 ? _a : `${context.containingFile.replace(/\.ts$/, `.${options === null || options === void 0 ? void 0 : options.inlineStylesExtension}`)}`;
                let stylesheetResult;
                try {
                    stylesheetResult = yield transform(data, `${filename}?direct`);
                }
                catch (e) {
                    console.error(`${e}`);
                }
                return { content: (stylesheetResult === null || stylesheetResult === void 0 ? void 0 : stylesheetResult.code) || '' };
            }
            return null;
        });
    };
}
exports.augmentHostWithResources = augmentHostWithResources;
//# sourceMappingURL=host.js.map